/*
 * Copyright (c) 2012, Masanori Miyamoto.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 * 1.Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * 2.Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE FREEBSD PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 */ 
#include <stdio.h>
#include <stdlib.h>
#include "lex_analyzer.h"
#include "parser.h"
#include "CzFStream.h"
#include "CzarBasic.h"
#include "CzarBasic_vm.h"

int main(int argc, char *argv[])
{
#ifdef LEX_TEST
	lex_test(argc, argv);
#endif
	CZFSTREAM stream;

	if(argc != 2) {
		fprintf(stderr, "CzarBasic Version 0.1.0\n");
		fprintf(stderr, "Copyright (C) 2012 by Masanori Miyamoto.\n");
		fprintf(stderr, "\n");
		fprintf(stderr, "usage:%s filename\n", argv[0]);
		exit(1);
	}
	/* t@CI[v */
	FILE *fp = fopen(argv[1], "r");
	if(!fp) {
		fprintf(stderr, "File open error\n");
		exit(1);
	}
	CzFStream_init(&stream, fp);

	/*  */
	parser((CZSTREAM*)&stream);

	stream.super.close((CZSTREAM*)&stream);

#ifdef PRINT_DISASM
	fprintf(stderr, "DISASM\n");
	vm_disasm();
#endif
	/* s */
	vm_run();

	return 0;
}
